#include <iostream>
#include <string>
#include "FileTrans.h"

#ifdef _WIN32
#include <windows.h>
#endif // _WIN32

using std::string;
using std::cout;
using std::endl;
using namespace AlibabaNlsCommon;

#if defined _WIN32
string UTF8ToGBK(const string &strUTF8) {

	int len = MultiByteToWideChar(CP_UTF8, 0, strUTF8.c_str(), -1, NULL, 0);
	unsigned short * wszGBK = new unsigned short[len + 1];
	memset(wszGBK, 0, len * 2 + 2);

	MultiByteToWideChar(CP_UTF8, 0, (char*)strUTF8.c_str(), -1, (wchar_t*)wszGBK, len);

	len = WideCharToMultiByte(CP_ACP, 0, (wchar_t*)wszGBK, -1, NULL, 0, NULL, NULL);

	char *szGBK = new char[len + 1];
	memset(szGBK, 0, len + 1);
	WideCharToMultiByte(CP_ACP, 0, (wchar_t*)wszGBK, -1, szGBK, len, NULL, NULL);

	string strTemp(szGBK);
	delete[] szGBK;
	delete[] wszGBK;

	return strTemp;
}
#endif

//文件转写
int fileTrans(const char* keySecret, const char* keyId, const char* appKey, const char* fileLink) {
	FileTrans FileTransRequest;

    /*设置阿里云账号KeySecret*/
    FileTransRequest.setKeySecret(keySecret);
    /*设置阿里云账号KeyId*/
    FileTransRequest.setAccessKeyId(keyId);
    /*设置阿里云AppKey*/
    FileTransRequest.setAppKey(appKey);
    /*设置音频文件url地址*/
    FileTransRequest.setFileLinkUrl(fileLink);

    FileTransRequest.setCustomParam("{\"auto_split\":true,\"version\": \"4.0\",\"enable_words\": true}");

    /*开始文件转写, 成功返回0, 失败返回-1*/
    if (-1 == FileTransRequest.applyFileTrans()) {
        cout << "Failed: " << FileTransRequest.getErrorMsg() << endl; /*获取失败原因*/

        return -1;
    } else {

#if defined _WIN32
        cout << "successed: " << UTF8ToGBK(FileTransRequest.getResult()) << endl;
#else
	cout << "successed: " << FileTransRequest.getResult() << endl;
#endif
	return 0;
    }
}

int main(int argc, char** argv) {

    if (argc < 4) {
        cout << "FileTransDemo need params : <AccessKey Id> <AccessKey Secret> <app - key>" << endl;
        return -1;
    }

    const char* accessKeyId = argv[1];
    const char* accessKeySecret = argv[2];
    const char* appKey = argv[3];
    const char* fileLink = "https://gw.alipayobjects.com/os/bmw-prod/0574ee2e-f494-45a5-820f-63aee583045a.wav";

    fileTrans(accessKeySecret, accessKeyId, appKey, fileLink);

    return 0;
}
